unit MyDialog;

interface

uses
  SysUtils;

const
  {$EXTERNALSYM OFN_READONLY}
  OFN_READONLY = $00000001;
  {$EXTERNALSYM OFN_OVERWRITEPROMPT}
  OFN_OVERWRITEPROMPT = $00000002;
  {$EXTERNALSYM OFN_HIDEREADONLY}
  OFN_HIDEREADONLY = $00000004;
  {$EXTERNALSYM OFN_NOCHANGEDIR}
  OFN_NOCHANGEDIR = $00000008;
  {$EXTERNALSYM OFN_SHOWHELP}
  OFN_SHOWHELP = $00000010;
  {$EXTERNALSYM OFN_ENABLEHOOK}
  OFN_ENABLEHOOK = $00000020;
  {$EXTERNALSYM OFN_ENABLETEMPLATE}
  OFN_ENABLETEMPLATE = $00000040;
  {$EXTERNALSYM OFN_ENABLETEMPLATEHANDLE}
  OFN_ENABLETEMPLATEHANDLE = $00000080;
  {$EXTERNALSYM OFN_NOVALIDATE}
  OFN_NOVALIDATE = $00000100;
  {$EXTERNALSYM OFN_ALLOWMULTISELECT}
  OFN_ALLOWMULTISELECT = $00000200;
  {$EXTERNALSYM OFN_EXTENSIONDIFFERENT}
  OFN_EXTENSIONDIFFERENT = $00000400;
  {$EXTERNALSYM OFN_PATHMUSTEXIST}
  OFN_PATHMUSTEXIST = $00000800;
  {$EXTERNALSYM OFN_FILEMUSTEXIST}
  OFN_FILEMUSTEXIST = $00001000;
  {$EXTERNALSYM OFN_CREATEPROMPT}
  OFN_CREATEPROMPT = $00002000;
  {$EXTERNALSYM OFN_SHAREAWARE}
  OFN_SHAREAWARE = $00004000;
  {$EXTERNALSYM OFN_NOREADONLYRETURN}
  OFN_NOREADONLYRETURN = $00008000;
  {$EXTERNALSYM OFN_NOTESTFILECREATE}
  OFN_NOTESTFILECREATE = $00010000;
  {$EXTERNALSYM OFN_NONETWORKBUTTON}
  OFN_NONETWORKBUTTON = $00020000;
  {$EXTERNALSYM OFN_NOLONGNAMES}
  OFN_NOLONGNAMES = $00040000;
  {$EXTERNALSYM OFN_EXPLORER}
  OFN_EXPLORER = $00080000;
  {$EXTERNALSYM OFN_NODEREFERENCELINKS}
  OFN_NODEREFERENCELINKS = $00100000;
  {$EXTERNALSYM OFN_LONGNAMES}
  OFN_LONGNAMES = $00200000;
  {$EXTERNALSYM OFN_ENABLEINCLUDENOTIFY}
  OFN_ENABLEINCLUDENOTIFY = $00400000;
  {$EXTERNALSYM OFN_ENABLESIZING}
  OFN_ENABLESIZING = $00800000;



type
  DWORD  = LongWord;
  HWND   = Pointer;
  HINST  = Cardinal;
  LPARAM = LongWord;
  WPARAM = LongWord;
  UINT   = LongWord;


 { TSaveDialog }
  TSaveDialog = class
    Buf : array[0..2048] of Char;
    function Execute: Boolean;
    function FileName: String;
  end;

 { TOpenDialog }
  TOpenDialog = class
    Buf : array[0..2048] of Char;
    function Execute: Boolean;
    function FileName: String;
  end;


 {$EXTERNALSYM tagOFNA}
  tagOFNA = packed record
    lStructSize: DWORD;
    hWndOwner: HWND;
    hInstance: HINST;
    lpstrFilter: PAnsiChar;
    lpstrCustomFilter: PAnsiChar;
    nMaxCustFilter: DWORD;
    nFilterIndex: DWORD;
    lpstrFile: PAnsiChar;
    nMaxFile: DWORD;
    lpstrFileTitle: PAnsiChar;
    nMaxFileTitle: DWORD;
    lpstrInitialDir: PAnsiChar;
    lpstrTitle: PAnsiChar;
    Flags: DWORD;
    nFileOffset: Word;
    nFileExtension: Word;
    lpstrDefExt: PAnsiChar;
    lCustData: LPARAM;
    lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
    lpTemplateName: PAnsiChar;
  end;



{$EXTERNALSYM GetSaveFileNameA}
function GetSaveFileNameA(var OpenFile: tagOFNA): Boolean; stdcall;

{$EXTERNALSYM MessageBox}
function MessageBox(hWnd: HWND; lpText, lpCaption: PChar; uType: UINT): Integer; stdcall;

{$EXTERNALSYM GetOpenFileNameA}
function GetOpenFileNameA(var OpenFile: tagOFNA): Boolean; stdcall;


//******************************************************************************
implementation

function GetOpenFileNameA;   external 'comdlg32.dll'  name 'GetOpenFileNameA';
function GetSaveFileNameA;   external 'comdlg32.dll'  name 'GetSaveFileNameA';
function MessageBox; external 'user32.dll' name 'MessageBoxA';




//==============================================================================
function TSaveDialog.Execute: Boolean;
var
  OpenFilename : tagOFNA;
begin
  Buf[0] := #0;
  with OpenFilename do begin
    lStructSize := SizeOf(tagOFNA);
    hWndOwner := nil;
    hInstance := SysInit.HInstance;
    lpstrFilter := nil;
    lpstrCustomFilter := nil;
    nMaxCustFilter := 0;
    nFilterIndex := 0;
    lpstrFile := Buf;
    nMaxFile := SizeOf(Buf);
    lpstrFileTitle := nil;
    nMaxFileTitle := 0;
    lpstrInitialDir := nil;
    lpstrTitle := nil;
    Flags := OFN_EXPLORER + OFN_LONGNAMES + OFN_OVERWRITEPROMPT + OFN_PATHMUSTEXIST + OFN_HIDEREADONLY;
    nFileOffset := 0;
    nFileExtension := 0;
    lpstrDefExt := nil;
    lCustData := 0;
    lpfnHook := nil;
    lpTemplateName := nil;
  end;

  Result := GetSaveFileNameA(OpenFilename);
end;


//==============================================================================
function TSaveDialog.FileName: String;
begin
  Result := StrPas(Buf);
end;


//==============================================================================
function TOpenDialog.Execute: Boolean;
var
  OpenFilename : tagOFNA;
begin
  Buf[0] := #0;
  with OpenFilename do begin
    lStructSize := SizeOf(tagOFNA);
    hWndOwner := nil;
    hInstance := SysInit.HInstance;
    lpstrFilter := nil;
    lpstrCustomFilter := nil;
    nMaxCustFilter := 0;
    nFilterIndex := 0;
    lpstrFile := Buf;
    nMaxFile := SizeOf(Buf);
    lpstrFileTitle := nil;
    nMaxFileTitle := 0;
    lpstrInitialDir := nil;
    lpstrTitle := nil;
    Flags := OFN_EXPLORER + OFN_LONGNAMES + OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST + OFN_HIDEREADONLY;
    nFileOffset := 0;
    nFileExtension := 0;
    lpstrDefExt := nil;
    lCustData := 0;
    lpfnHook := nil;
    lpTemplateName := nil;
  end;

  Result := GetOpenFileNameA(OpenFilename);
end;


//==============================================================================
function TOpenDialog.FileName: String;
begin
  Result := StrPas(Buf);
end;




end.





